package WebFlow.EventTest1; 
import WebFlow.*; 
import java.util.*; 
import WebFlow.event.*; 
import WebFlow.EventTest2.*;

import java.io.*;
import java.awt.*; 
import java.awt.event.*; 
import javax.swing.*; 

public class EventTest1Impl extends BeanContextChildSupport
                      implements WebFlow.EventTest1.EventTest1Operations
{
    String msg_ ; 
    org.omg.CORBA.Object peer ;

    public static int numClicks = 0 ; // number of button clicks
    public static String message = "Number of Button Clicks:"+numClicks; 
    public static JButton fire =  new JButton("Fire Button");
    public static JButton quit = new JButton("Quit Button");
    public static JButton reset = new JButton("Reset Button");
    public static final JLabel label1 = new JLabel(message);
    
    public Component createComponents(){ 

	label1.setLabelFor(fire); 

	JPanel pane1 = new JPanel(); 
	pane1.setBorder(BorderFactory.createEmptyBorder(30,30,30,30)); 
	pane1.setLayout(new GridLayout(0,1)); 

	pane1.add(fire); 
	pane1.add(label1); 
	pane1.add(reset); 
	pane1.add(quit); 
	
	fire.setBackground(Color.cyan); 
	reset.setBackground(Color.cyan); 
	quit.setBackground(Color.cyan); 
	
	fire.setForeground(Color.red); 
	reset.setForeground(Color.blue); 
	quit.setForeground(Color.black); 
	
	fire.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    runfire();
		    System.out.println("Fire button clicked");
           
		}
	    });

	reset.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    runreset();
		    System.out.println("Reset button clicked");
           
		}
	    });

	quit.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e) {
		    runquit();
		    System.out.println("Quit button clicked");

		}
	    });
	
	return pane1 ; 
    }

    public EventTest1Impl(org.omg.CORBA.Object peer , String msg)
	throws WebFlow.NullPointerException
    {
	super(peer); 
	this.peer = peer ; 
	msg_ = msg ; 
    }

    public String test() {
	return "Action is up!!!!!!!"; }

    public void runvision1()
    {
	System.out.println("Frame1 in vision "); 

	final JFrame frame1 = new JFrame("Action Performed");
	frame1.getContentPane().add(createComponents() , BorderLayout.CENTER);
	frame1.pack();
	frame1.setVisible(true);

	/*
	actionEvent aevt = new actionEventImpl(getBeanContextChildPeer(),
					       "Show1"); 
	fireEvent("Fire_Vision1" , aevt);
	*/ 
    }

    public void runfire()
    {
	System.out.println("Frame1 in run: fire"); 

	numClicks++ ; 
	message = "Number of Button Clicks:" +numClicks; 
	label1.setText(message); 
	
	WebFlow.EventTest2.actionEvent aevt = new WebFlow.EventTest2.actionEventImpl(getBeanContextChildPeer(),
					       "Fire");
	fireEvent( "Fire_Button" , aevt); 
    }

    public void runreset()
    {
	numClicks = 0 ; 
	message = "Number of Button Clicks:" + numClicks ;  
	label1.setText(message) ; 
	
	WebFlow.EventTest2.actionEvent aevt = new WebFlow.EventTest2.actionEventImpl(getBeanContextChildPeer(),
					       "Reset");
	fireEvent("Reset_Button" , aevt); 
    }

    public void runquit()
    {
	WebFlow.EventTest2.actionEvent aevt = new
	    WebFlow.EventTest2.actionEventImpl(getBeanContextChildPeer(),"Quit"); 
	fireEvent("Quit_Button" , aevt); 

	BeanContextChild  prev_bcc,last_bcc;
	last_bcc = BeanContextChildHelper.narrow(getBeanContext());
	prev_bcc = last_bcc;

	while(last_bcc !=null){
	    prev_bcc = last_bcc;
	    last_bcc = BeanContextChildHelper.narrow(last_bcc.getBeanContext());
	}
	WebFlowContext wfc = WebFlowContextHelper.narrow(prev_bcc);
	wfc.removeMyself(); 
    }

}







